#include <linux/module.h>	/* Needed by all modules */
#include <linux/kernel.h>	/* Needed for KERN_INFO */
#include <linux/init.h>		/* Needed for the macros */
#include <linux/mm.h>
#include <linux/highmem.h>
#include <linux/pid.h>
#include <linux/ptrace.h>
#include <linux/pid.h>
#include <linux/uaccess.h>
#include <linux/sched.h>
#include <linux/errno.h>
#include <linux/pagemap.h>
#include <linux/ptrace.h>
#include <linux/security.h>
#include <asm/pgtable.h>
#include <asm/uaccess.h>
#define DRIVER_AUTHOR "Dylan Murphy-Mancini"
#define DRIVER_DESC   "'Hello, World' LKM"

MODULE_LICENSE("GPL");
MODULE_AUTHOR(DRIVER_AUTHOR);	/* Who wrote this module? */
MODULE_DESCRIPTION(DRIVER_DESC);	/* What does this module do */
MODULE_SUPPORTED_DEVICE("testdevice");


struct task_struct *task;
struct pid *pid_struct;
struct mm_struct *mm;
struct vm_area_struct *vma;
struct page *page;
char buf[128];
void *old_buf = buf;
pid_t pid;

static int __init init_func(void){

	printk("Hello, world init\n");

	pid = 28035;

	pid_struct = find_get_pid(pid);
	task = pid_task(pid_struct,PIDTYPE_PID);

	rcu_read_lock();

	if (task){
		mm = task->mm;

		printk("\nThis mm_struct has %d vmas.\n", mm->map_count);
		printk("\nCode  Segment start = 0x%lx, end = 0x%lx \n"
                  "Data  Segment start = 0x%lx, end = 0x%lx\n"
                  "Stack Segment start = 0x%lx\n",
                  mm->start_code, mm->end_code,
                  mm->start_data, mm->end_data,
                  mm->start_stack);
	}

	rcu_read_unlock();

	return 0;
}

static void __exit cleanup_func(void){
	printk(KERN_INFO "Hello, world cleanup\n");
}

module_init(init_func);
module_exit(cleanup_func);
