#include <sys/ptrace.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/syscall.h>
#include <sys/reg.h>
#include <sys/user.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>

#define TARGET "/home/us3r/Desktop/plan/target"
#define NEW_UID 1337

int main(int argc,char** argv) {
  int status = 0;
  int syscall_n = 0;
  int entering = 1;
  struct user_regs_struct regs;
  int pid = fork();

  if (!pid) {
    ptrace( PTRACE_TRACEME, 0, 0, 0 );
    execv( TARGET, argv );
  } else {
    wait( &status );

    while (1) {
      ptrace( PTRACE_SYSCALL, pid, 0, 0 );

      wait( &status );

      if ( WIFEXITED( status ) ) break;

      ptrace( PTRACE_GETREGS, pid, NULL, &regs );
      syscall_n = regs.orig_rax;
      if ( syscall_n == SYS_getuid ) {
        if ( entering ) {
          entering = 0;
        }
        else {
          ptrace( PTRACE_GETREGS, pid, 0, &regs );
          regs.rax = NEW_UID;
          ptrace( PTRACE_SETREGS, pid, 0, &regs );
          entering = 1;
        }
      }
    }
  }

  return 0;
}