/*

fraction_sum_search.c

DESC:

A brute-force solution to the problem: what permutation of the digits from 1 to 9 will add to 1 when arranged in a form similar to 1/23 + 4/56 + 7/89 ?

RUN:

$ gcc fraction_sum_search.c -o fss
$ ./fss
5/34 + 7/68 + 9/12 = 1
5/34 + 9/12 + 7/68 = 1
7/68 + 5/34 + 9/12 = 1
7/68 + 9/12 + 5/34 = 1
9/12 + 5/34 + 7/68 = 1
9/12 + 7/68 + 5/34 = 1
Execution time: 0.018168 seconds

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#define ARRAY_LEN 9

unsigned cc(unsigned x, unsigned y) {
    unsigned pow = 10;
    while(y >= pow){ pow *= 10; }
    return x * pow + y;        
}

void swap(int *x, int *y){
	if (x != y) {
		*x ^= *y;
		*y ^= *x;
		*x ^= *y;
	}
}

void printArray(int array[]){
	for (int i = 0; i < ARRAY_LEN; ++i){
		printf("%i", array[i]);
	}
	printf("\n");
}

void pp(int a[]){
	printf("%i/%i%i + %i/%i%i + %i/%i%i = 1\n", a[0], a[1], a[2], a[3], a[4], a[5], a[6], a[7], a[8]);
}

int testArray(int a[]){
	if ((float)a[0]/cc(a[1],a[2])+(float)a[3]/cc(a[4],a[5])+(float)a[6]/cc(a[7],a[8]) == 1){
		return 1;
	}
	return 0;
}


void permute(int *array,int i,int length) { 
	
	if (length == i){
		if (testArray(array)==1){
			pp(array);
		}
	} 

	int j = i;
	for (j = i; j < length; j++) { 
		swap(array+i,array+j);
		permute(array,i+1,length);
		swap(array+i,array+j);

	}
}

int main(int argc, char const *argv[]){
	clock_t begin,end;
	double time_spent;
	int digits[ARRAY_LEN];

	begin = clock();

	for (int i = 0; i < ARRAY_LEN; ++i){
		digits[i] = i+1;
	} 

    permute(digits, 0, ARRAY_LEN);

    end = clock();

    printf("Execution time: %f seconds\n", (double)(end - begin) / CLOCKS_PER_SEC);
	
	return 0;
}
