"""

fraction_sum_search_imperative.py

DESC:

A brute-force solution to the problem: what permutation of the digits from 1 to 9 will add to 1 when arranged in a form similar to 1/23 + 4/56 + 7/89 ?

RUN:

$ python3 fraction_sum_search_imperative.py 
(5, 3, 4, 7, 6, 8, 9, 1, 2)
(5, 3, 4, 9, 1, 2, 7, 6, 8)
(7, 6, 8, 5, 3, 4, 9, 1, 2)
(7, 6, 8, 9, 1, 2, 5, 3, 4)
(9, 1, 2, 5, 3, 4, 7, 6, 8)
(9, 1, 2, 7, 6, 8, 5, 3, 4)
Execution time 0.6378731727600098 seconds.

"""

import itertools
import math
import time

def cc(x, y):
    return x*10+y

digits = range(1,10)

perms = list(itertools.permutations(digits))

t = time.time()
for p in perms:
	if (float(p[0])/cc(p[1],p[2])+float(p[3])/cc(p[4],p[5])+float(p[6])/cc(p[7],p[8])==1):
		print("{}".format(p))
		
print("Execution time {} seconds.".format(time.time()-t))
